  PROGRAM

treeNode    CLASS,TYPE
PrimKey     ULONG
RecPos      LONG
ltree       &treeNode
rtree       &treeNode
            END

  INCLUDE('binTree.INC'),ONCE

  MAP
  END

  CODE

!----------------------------------------------------
binTree.Construct             PROCEDURE()
!----------------------------------------------------

   CODE



!----------------------------------------------------
binTree.Destruct              PROCEDURE()
!----------------------------------------------------

   CODE


!-----------------------------------------------------------------------------
binTree.Init                  PROCEDURE()
!-----------------------------------------------------------------------------

   CODE

   SELF.root &= NULL

!-----------------------------------------------------------------------------
binTree.kill               PROCEDURE()
!-----------------------------------------------------------------------------
    CODE

    SELF.root &= SELF.del(SELF.root)

!-----------------------------------------------------------------------------
binTree.del               PROCEDURE(*treeNode t)
!-----------------------------------------------------------------------------

    CODE

    IF ~t &= NULL
      t.ltree &= SELF.del(t.ltree)
      t.rtree &= SELF.del(t.rtree)
      SELF.curr &= t
      DISPOSE(SELF.curr)
      SELF.curr &= NULL
    END 

    RETURN t

!-----------------------------------------------------------------------------
binTree.isEmpty               PROCEDURE()
!-----------------------------------------------------------------------------

    CODE

    RETURN CHOOSE(SELF.root &= NULL,TRUE,FALSE)

!-----------------------------------------------------------------------------
binTree.BTinsert               PROCEDURE(ULONG yourVal,LONG yourPos)
!-----------------------------------------------------------------------------
i   BOOL(FALSE)

    CODE
    SELF.root &= SELF.Binsert(SELF.root,yourVal,i,yourPos)
    RETURN i

!-----------------------------------------------------------------------------
binTree.Binsert         PROCEDURE(*treeNode t, ULONG yourVal, *BOOL flag, LONG yourPos)
!-----------------------------------------------------------------------------

    CODE

    IF ~t &= NULL AND t.primKey = yourVal THEN flag = FALSE.

    IF t &= NULL
      SELF.curr &= NEW(treeNode)
?     ASSERT(~SELF.curr &= NULL)

      t &= SELF.curr
      t.ltree &= NULL
      t.rtree &= NULL

      t.primKey = yourVal
      t.recPos = yourPos
      flag = TRUE
    END

    IF yourVal > t.primKey
      t.rtree &= SELF.Binsert(t.rtree,yourVal,flag,yourPos)
    ELSIF yourVal < t.primKey
      t.ltree &= SELF.Binsert(t.ltree,yourVal,flag,yourPos)
    END

    RETURN t

!-----------------------------------------------------------------------------
binTree.BTheight            PROCEDURE()
!-----------------------------------------------------------------------------

    CODE

    RETURN SELF.Bheight(SELF.root)

!-----------------------------------------------------------------------------
binTree.Bheight         PROCEDURE(*treeNode t)
!-----------------------------------------------------------------------------
L   ULONG
R   ULONG

    CODE

    IF t &= NULL THEN RETURN 0.

    L = SELF.Bheight(t.ltree)
    R = SELF.Bheight(t.rtree)

    RETURN CHOOSE(L > R, 1 + L, 1 + R)
!-----------------------------------------------------------------------------
binTree.BTfind          PROCEDURE(ULONG yourVal)
!-----------------------------------------------------------------------------

    CODE

    RETURN SELF.Bfind(SELF.root, yourVal)

!-----------------------------------------------------------------------------
binTree.Bfind           PROCEDURE(*treeNode t,ULONG yourVal)
!-----------------------------------------------------------------------------

    CODE

    IF t &= NULL THEN RETURN FALSE.

    IF t.primKey = yourVal THEN SELF.curr &= t; RETURN t.recPos.

    IF t.primKey < yourVal
      RETURN SELF.Bfind(t.rtree, yourVal)
    ELSE
      RETURN SELF.Bfind(t.ltree, yourVal)
    END     